#include "stdmap.h"

Orbit cantorus;

Orbit FindCantorus()
{
	static char path[255] = "-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+";
	Orbit Lower,Upper;

	DefOrbit(&Lower,0L,1L,MINIMAX);
	DefOrbit(&Upper,1L,1L,MINIMAX);
	FareyPath(Lower,Upper,path);
	return(cantorus);
}

void FareyPath(Orbit lower,Orbit upper,char *pathstr)
{
	Orbit mediant;

	DefOrbit(&mediant,lower.p+upper.p,lower.q+upper.q, MINIMAX);
	mediant.y = 0.5*(upper.y + lower.y);

	if(!secant(&mediant,0.1*(upper.y -lower.y)))
		return;

	cantorus.x = mediant.x, cantorus.y = mediant.y,cantorus.q = mediant.q;

	switch(pathstr[0])
	{
		default:
			printf("Path must be +'s and -'s");
		case '+':
			FareyPath(mediant,upper,++pathstr);
			break;
		case '-':
			FareyPath(lower,mediant,++pathstr);
			break;
		case '\0':
			break;
	}
	return;
}

void DefOrbit(theOrbit,p,q,type)
Orbit *theOrbit;
long p,q;
int type;
{
	theOrbit->p = p;
	theOrbit->q = q;
	theOrbit->type = type;
	theOrbit->x = 0.0;
	theOrbit->y = (double)p/(double)q;

}


