#include "stdmap.h"

long p,q;
int theType;

secant(theOrbit,dy)
Orbit *theOrbit;
double dy;
{
	double v,vo,dv;	
	double y;
	register int iterations = ITMAX;
	
	y = theOrbit->y;
	p = theOrbit->p;
	q = theOrbit->q;
	theType = theOrbit->type;

	if(theType==MINIMIZE)
		if(q%2) theType = FIXSR;
		else theType = FIXTS;

	v = HalfOrbit(y);

	while(--iterations)
	{
		y+= dy;
		vo = v;
		v = HalfOrbit(y);
		
		if((dv = vo-v) == 0.0 && v!=0.0)
			return(0);
		
		dy *= v/dv;
		
		if(fabs(v) < ERRv)
			break;
		else if(fabs(dy) < ERRy)
			return(0);
	}
	theOrbit->y = y;
	theOrbit->x = Symmetry(y,theType,0L);
	return(iterations);
}

double HalfOrbit(y)
double y;
{
	double x;
	register long l;
	extern double k,tpi;

	l = (q+1)/2;
	if((theType >=FIXTS) && (q%2)) l-=1;

	x = Symmetry(y,theType,0L);

	while(l-->0)
	{
		y -= k*sin(tpi*x);
		x += y;
	}
	if(q%2)
		x -= Symmetry(y,(theType%4)+2,p);
	else
		x -= Symmetry(y,theType,p);
	return(x);
}

double Symmetry(y,type,m)
double y;
int type;
long m;
{
	if(type%2) type-=1,m+=1;
	switch(type)
	{
		case FIXS:
			return(0.5*m);
		case FIXTS:
			return(0.5*y + 0.5*m);
		default:
			printf("Improper symmetry type");
	}
}
