#include <gl/gl.h>
#include <stdio.h>
#include <device.h>
#include "stdmap.h"


extern PlotData plotSize;

void GlobalToLocal(Point thePt, double *localPt)
{
    Screencoord vpl,vpr,vpb,vpt;
    long ox,oy;

    getorigin(&ox,&oy);
    thePt.h-=ox;
    thePt.v-=oy;

    getviewport(&vpl,&vpr,&vpb,&vpt);

    localPt[0] = (thePt.h-vpl)*(plotSize.xmax-plotSize.xmin)/(vpr-vpl +1)  + plotSize.xmin;
    localPt[1]= (thePt.v-vpb)*(plotSize.ymax-plotSize.ymin)/(vpt-vpb +1)  + plotSize.ymin;
}


void GetMouse(Point *thePt)
{
    Screencoord sx, sy;	
    thePt->h=getvaluator(MOUSEX);
    thePt->v=getvaluator(MOUSEY);	
}

Boolean isPressed(int Key)	//return true if Key is down
{
    return(FALSE);
}
